// ignore_for_file: non_constant_identifier_names

import 'package:app_template/app_template_data/app_template_sign.dart';
import 'package:app_template/page/home.dart';
import 'package:app_template/widget/app_template.dart';
import 'package:flutter/material.dart';
import 'package:flutter_hicons/flutter_hicons.dart';
import 'package:general_lib_flutter/general_lib_flutter_core.dart';

import 'dart:async';

class SignPageAppTemplate extends AppTemplateStatefulWidget {
  const SignPageAppTemplate({super.key, required super.appTemplateData});

  @override
  State<SignPageAppTemplate> createState() => _SignPageAppTemplateState();
}

class _SignPageAppTemplateState extends State<SignPageAppTemplate> {
  int activeIndex = 0;
  bool is_current_page = true;

  final ValueNotifier<bool> theme_notifier = ValueNotifier(false);
  // SignPageType signPageType = SignPageType.sign_in;
  final ValueNotifier<SignPageType> signPageTypeValueNotifier = ValueNotifier(SignPageType.sign_in);

  @override
  void initState() {
    super.initState();
    WidgetsBinding.instance.addPostFrameCallback((_) {
      task();
    });
  }

  task() {
    Timer.periodic(const Duration(seconds: 5), (timer) {
      try {
        setState(() {
          activeIndex++;
          if (activeIndex == 4) activeIndex = 0;
        });
      } catch (e) {
        timer.cancel();
      }
    });
  }

  @override
  void dispose() {
    super.dispose();
  }

  @override
  Widget build(BuildContext context) {
    return Scaffold(
      body: ValueListenableBuilder<SignPageType>(
        valueListenable: signPageTypeValueNotifier,
        builder: (_, SignPageType signPageType, __) {
          if (signPageType == SignPageType.sign_up) {
            return signUpBody();
          }
          if (signPageType == SignPageType.reset_password) {
            return resetPasswordBody();
          }
          return signInBody();
        },
      ),
    );
  }

  Widget signInBody() {
    return SingleChildScrollView(
      child: Padding(
        padding: const EdgeInsets.all(20.0),
        child: Column(
          children: [
            const SizedBox(
              height: 50,
            ),
            const SizedBox(
              height: 350,
              child: Stack(
                children: [
                  // Positioned(
                  //   top: 0,
                  //   left: 0,
                  //   right: 0,
                  //   bottom: 0,
                  //   child: AnimatedOpacity(
                  //     opacity: activeIndex == 0 ? 1 : 0,
                  //     duration: const Duration(
                  //       seconds: 1,
                  //     ),
                  //     curve: Curves.linear,
                  //     child: Image.network(
                  //       'https://ouch-cdn2.icons8.com/As6ct-Fovab32SIyMatjsqIaIjM9Jg1PblII8YAtBtQ/rs:fit:784:784/czM6Ly9pY29uczgu/b3VjaC1wcm9kLmFz/c2V0cy9zdmcvNTg4/LzNmMDU5Mzc0LTky/OTQtNDk5MC1hZGY2/LTA2YTkyMDZhNWZl/NC5zdmc.png',
                  //       height: 400,
                  //     ),
                  //   ),
                  // ),
                  // Positioned(
                  //   top: 0,
                  //   left: 0,
                  //   right: 0,
                  //   bottom: 0,
                  //   child: AnimatedOpacity(
                  //     opacity: activeIndex == 1 ? 1 : 0,
                  //     duration: const Duration(seconds: 1),
                  //     curve: Curves.linear,
                  //     child: Image.network(
                  //       'https://ouch-cdn2.icons8.com/vSx9H3yP2D4DgVoaFPbE4HVf6M4Phd-8uRjBZBnl83g/rs:fit:784:784/czM6Ly9pY29uczgu/b3VjaC1wcm9kLmFz/c2V0cy9zdmcvNC84/MzcwMTY5OS1kYmU1/LTQ1ZmEtYmQ1Ny04/NTFmNTNjMTlkNTcu/c3Zn.png',
                  //       height: 400,
                  //     ),
                  //   ),
                  // ),
                  // Positioned(
                  //   top: 0,
                  //   left: 0,
                  //   right: 0,
                  //   bottom: 0,
                  //   child: AnimatedOpacity(
                  //     opacity: activeIndex == 2 ? 1 : 0,
                  //     duration: const Duration(seconds: 1),
                  //     curve: Curves.linear,
                  //     child: Image.network(
                  //       'https://ouch-cdn2.icons8.com/fv7W4YUUpGVcNhmKcDGZp6pF1-IDEyCjSjtBB8-Kp_0/rs:fit:784:784/czM6Ly9pY29uczgu/b3VjaC1wcm9kLmFz/c2V0cy9zdmcvMTUv/ZjUzYTU4NDAtNjBl/Yy00ZWRhLWE1YWIt/ZGM1MWJmYjBiYjI2/LnN2Zw.png',
                  //       height: 400,
                  //     ),
                  //   ),
                  // ),
                  // Positioned(
                  //   top: 0,
                  //   left: 0,
                  //   right: 0,
                  //   bottom: 0,
                  //   child: AnimatedOpacity(
                  //     opacity: activeIndex == 3 ? 1 : 0,
                  //     duration: const Duration(seconds: 1),
                  //     curve: Curves.linear,
                  //     child: Image.network(
                  //       'https://ouch-cdn2.icons8.com/AVdOMf5ui4B7JJrNzYULVwT1z8NlGmlRYZTtg1F6z9E/rs:fit:784:767/czM6Ly9pY29uczgu/b3VjaC1wcm9kLmFz/c2V0cy9zdmcvOTY5/L2NlMTY1MWM5LTRl/ZjUtNGRmZi05MjQ3/LWYzNGQ1MzhiOTQ0/Mi5zdmc.png',
                  //       height: 400,
                  //     ),
                  //   ),
                  // ),
                ],
              ),
            ),
            const SizedBox(
              height: 40,
            ),
            textFormField(
              labelText: "Username",
              hintText: "general",
              iconData: Hicons.user_tag_2_bold,
            ),
            textFormField(
              labelText: "Password",
              hintText: "password 1213 ./;",
              iconData: Icons.key,
            ),
            Row(
              mainAxisAlignment: MainAxisAlignment.end,
              children: [
                TextButton(
                  onPressed: () {
                    setState(() {
                      signPageTypeValueNotifier.value = SignPageType.reset_password;
                    });
                  },
                  child: Text(
                    'Forgot Password?',
                    style: TextStyle(
                      color: context.theme.indicatorColor,
                      fontSize: 14.0,
                      fontWeight: FontWeight.w400,
                    ),
                  ),
                )
              ],
            ),
            const SizedBox(
              height: 30,
            ),
            Container(
              width: context.width,
              decoration: const BoxDecoration(color: Colors.blue, borderRadius: BorderRadius.all(Radius.circular(20))),
              clipBehavior: Clip.antiAlias,
              child: MaterialButton(
                onPressed: () async {
                  await context.navigator().pushReplacement(PageRouteBuilder(
                    pageBuilder: (context, animation, secondaryAnimation) {
                      HomePageAppTemplate homePageAppTemplate = HomePageAppTemplate(appTemplateData: widget.appTemplateData);

                      return homePageAppTemplate;
                    },
                  ));
                },
                height: 45,
                padding: const EdgeInsets.symmetric(vertical: 10, horizontal: 50),
                shape: RoundedRectangleBorder(
                  borderRadius: BorderRadius.circular(10.0),
                ),
                child: const Text(
                  "Login",
                  style: TextStyle(color: Colors.white, fontSize: 16.0),
                ),
              ),
            ),
            const SizedBox(
              height: 30,
            ),
            Row(
              mainAxisAlignment: MainAxisAlignment.center,
              children: [
                Text(
                  'Don\'t have an account?',
                  style: TextStyle(color: context.theme.indicatorColor, fontSize: 14.0, fontWeight: FontWeight.w400),
                ),
                TextButton(
                  onPressed: () {
                    setState(() {
                      signPageTypeValueNotifier.value = SignPageType.sign_up;
                    });
                  },
                  child: const Text(
                    'Register',
                    style: TextStyle(color: Colors.blue, fontSize: 14.0, fontWeight: FontWeight.w400),
                  ),
                )
              ],
            ),
          ],
        ),
      ),
    );
  }

  Widget signUpBody() {
    return SingleChildScrollView(
      child: Padding(
        padding: const EdgeInsets.all(20.0),
        child: Column(
          children: [
            const SizedBox(
              height: 50,
            ),
            const SizedBox(
              height: 350,
              child: Stack(
                children: [
                  // Positioned(
                  //   top: 0,
                  //   left: 0,
                  //   right: 0,
                  //   bottom: 0,
                  //   child: AnimatedOpacity(
                  //     opacity: activeIndex == 0 ? 1 : 0,
                  //     duration: const Duration(
                  //       seconds: 1,
                  //     ),
                  //     curve: Curves.linear,
                  //     child: Image.network(
                  //       'https://ouch-cdn2.icons8.com/As6ct-Fovab32SIyMatjsqIaIjM9Jg1PblII8YAtBtQ/rs:fit:784:784/czM6Ly9pY29uczgu/b3VjaC1wcm9kLmFz/c2V0cy9zdmcvNTg4/LzNmMDU5Mzc0LTky/OTQtNDk5MC1hZGY2/LTA2YTkyMDZhNWZl/NC5zdmc.png',
                  //       height: 400,
                  //     ),
                  //   ),
                  // ),
                  // Positioned(
                  //   top: 0,
                  //   left: 0,
                  //   right: 0,
                  //   bottom: 0,
                  //   child: AnimatedOpacity(
                  //     opacity: activeIndex == 1 ? 1 : 0,
                  //     duration: const Duration(seconds: 1),
                  //     curve: Curves.linear,
                  //     child: Image.network(
                  //       'https://ouch-cdn2.icons8.com/vSx9H3yP2D4DgVoaFPbE4HVf6M4Phd-8uRjBZBnl83g/rs:fit:784:784/czM6Ly9pY29uczgu/b3VjaC1wcm9kLmFz/c2V0cy9zdmcvNC84/MzcwMTY5OS1kYmU1/LTQ1ZmEtYmQ1Ny04/NTFmNTNjMTlkNTcu/c3Zn.png',
                  //       height: 400,
                  //     ),
                  //   ),
                  // ),
                  // Positioned(
                  //   top: 0,
                  //   left: 0,
                  //   right: 0,
                  //   bottom: 0,
                  //   child: AnimatedOpacity(
                  //     opacity: activeIndex == 2 ? 1 : 0,
                  //     duration: const Duration(seconds: 1),
                  //     curve: Curves.linear,
                  //     child: Image.network(
                  //       'https://ouch-cdn2.icons8.com/fv7W4YUUpGVcNhmKcDGZp6pF1-IDEyCjSjtBB8-Kp_0/rs:fit:784:784/czM6Ly9pY29uczgu/b3VjaC1wcm9kLmFz/c2V0cy9zdmcvMTUv/ZjUzYTU4NDAtNjBl/Yy00ZWRhLWE1YWIt/ZGM1MWJmYjBiYjI2/LnN2Zw.png',
                  //       height: 400,
                  //     ),
                  //   ),
                  // ),
                  // Positioned(
                  //   top: 0,
                  //   left: 0,
                  //   right: 0,
                  //   bottom: 0,
                  //   child: AnimatedOpacity(
                  //     opacity: activeIndex == 3 ? 1 : 0,
                  //     duration: const Duration(seconds: 1),
                  //     curve: Curves.linear,
                  //     child: Image.network(
                  //       'https://ouch-cdn2.icons8.com/AVdOMf5ui4B7JJrNzYULVwT1z8NlGmlRYZTtg1F6z9E/rs:fit:784:767/czM6Ly9pY29uczgu/b3VjaC1wcm9kLmFz/c2V0cy9zdmcvOTY5/L2NlMTY1MWM5LTRl/ZjUtNGRmZi05MjQ3/LWYzNGQ1MzhiOTQ0/Mi5zdmc.png',
                  //       height: 400,
                  //     ),
                  //   ),
                  // ),
                ],
              ),
            ),
            const SizedBox(
              height: 40,
            ),
            textFormField(
              labelText: "Username",
              hintText: "general",
              iconData: Hicons.user_tag_2_bold,
            ),
            textFormField(
              labelText: "Phone Number",
              hintText: "+658362894910",
              iconData: Hicons.call_light_outline,
            ),
            textFormField(
              labelText: "Password",
              hintText: "password 1213 ./;",
              iconData: Icons.key,
              valueState: theme_notifier,
            ),
            textFormField(
              labelText: "Password",
              hintText: "password 1213 ./;",
              iconData: Icons.key,
              valueState: theme_notifier,
              // is_secret_data: true,
            ),
            Row(
              mainAxisAlignment: MainAxisAlignment.end,
              children: [
                TextButton(
                  onPressed: () {
                    setState(() {
                      signPageTypeValueNotifier.value = SignPageType.reset_password;
                    });
                  },
                  child: Text(
                    'Forgot Password?',
                    style: TextStyle(
                      color: context.theme.indicatorColor,
                      fontSize: 14.0,
                      fontWeight: FontWeight.w400,
                    ),
                  ),
                )
              ],
            ),
            const SizedBox(
              height: 30,
            ),
            Container(
              width: context.width,
              decoration: const BoxDecoration(color: Colors.blue, borderRadius: BorderRadius.all(Radius.circular(20))),
              clipBehavior: Clip.antiAlias,
              child: MaterialButton(
                onPressed: () async {
                  await context.navigator().pushReplacement(PageRouteBuilder(
                    pageBuilder: (context, animation, secondaryAnimation) {
                      HomePageAppTemplate homePageAppTemplate = HomePageAppTemplate(appTemplateData: widget.appTemplateData);

                      return homePageAppTemplate;
                    },
                  ));
                },
                height: 45,
                padding: const EdgeInsets.symmetric(vertical: 10, horizontal: 50),
                shape: RoundedRectangleBorder(
                  borderRadius: BorderRadius.circular(10.0),
                ),
                child: const Text(
                  "Sign Up",
                  style: TextStyle(color: Colors.white, fontSize: 16.0),
                ),
              ),
            ),
            const SizedBox(
              height: 30,
            ),
            Row(
              mainAxisAlignment: MainAxisAlignment.center,
              children: [
                Text(
                  'Have an account?',
                  style: TextStyle(color: context.theme.indicatorColor, fontSize: 14.0, fontWeight: FontWeight.w400),
                ),
                TextButton(
                  onPressed: () {
                    setState(() {
                      signPageTypeValueNotifier.value = SignPageType.sign_in;
                    });
                  },
                  child: const Text(
                    'Login',
                    style: TextStyle(color: Colors.blue, fontSize: 14.0, fontWeight: FontWeight.w400),
                  ),
                ),
              ],
            ),
          ],
        ),
      ),
    );
  }

  Widget resetPasswordBody() {
    // return SizedBox.shrink();
    return SingleChildScrollView(
      child: Padding(
        padding: const EdgeInsets.all(20.0),
        child: Column(
          children: [
            const SizedBox(
              height: 50,
            ),
            const SizedBox(
              height: 350,
              child: Stack(
                children: [
                  // Positioned(
                  //   top: 0,
                  //   left: 0,
                  //   right: 0,
                  //   bottom: 0,
                  //   child: AnimatedOpacity(
                  //     opacity: activeIndex == 0 ? 1 : 0,
                  //     duration: const Duration(
                  //       seconds: 1,
                  //     ),
                  //     curve: Curves.linear,
                  //     child: Image.network(
                  //       'https://ouch-cdn2.icons8.com/As6ct-Fovab32SIyMatjsqIaIjM9Jg1PblII8YAtBtQ/rs:fit:784:784/czM6Ly9pY29uczgu/b3VjaC1wcm9kLmFz/c2V0cy9zdmcvNTg4/LzNmMDU5Mzc0LTky/OTQtNDk5MC1hZGY2/LTA2YTkyMDZhNWZl/NC5zdmc.png',
                  //       height: 400,
                  //     ),
                  //   ),
                  // ),
                  // Positioned(
                  //   top: 0,
                  //   left: 0,
                  //   right: 0,
                  //   bottom: 0,
                  //   child: AnimatedOpacity(
                  //     opacity: activeIndex == 1 ? 1 : 0,
                  //     duration: const Duration(seconds: 1),
                  //     curve: Curves.linear,
                  //     child: Image.network(
                  //       'https://ouch-cdn2.icons8.com/vSx9H3yP2D4DgVoaFPbE4HVf6M4Phd-8uRjBZBnl83g/rs:fit:784:784/czM6Ly9pY29uczgu/b3VjaC1wcm9kLmFz/c2V0cy9zdmcvNC84/MzcwMTY5OS1kYmU1/LTQ1ZmEtYmQ1Ny04/NTFmNTNjMTlkNTcu/c3Zn.png',
                  //       height: 400,
                  //     ),
                  //   ),
                  // ),
                  // Positioned(
                  //   top: 0,
                  //   left: 0,
                  //   right: 0,
                  //   bottom: 0,
                  //   child: AnimatedOpacity(
                  //     opacity: activeIndex == 2 ? 1 : 0,
                  //     duration: const Duration(seconds: 1),
                  //     curve: Curves.linear,
                  //     child: Image.network(
                  //       'https://ouch-cdn2.icons8.com/fv7W4YUUpGVcNhmKcDGZp6pF1-IDEyCjSjtBB8-Kp_0/rs:fit:784:784/czM6Ly9pY29uczgu/b3VjaC1wcm9kLmFz/c2V0cy9zdmcvMTUv/ZjUzYTU4NDAtNjBl/Yy00ZWRhLWE1YWIt/ZGM1MWJmYjBiYjI2/LnN2Zw.png',
                  //       height: 400,
                  //     ),
                  //   ),
                  // ),
                  // Positioned(
                  //   top: 0,
                  //   left: 0,
                  //   right: 0,
                  //   bottom: 0,
                  //   child: AnimatedOpacity(
                  //     opacity: activeIndex == 3 ? 1 : 0,
                  //     duration: const Duration(seconds: 1),
                  //     curve: Curves.linear,
                  //     child: Image.network(
                  //       'https://ouch-cdn2.icons8.com/AVdOMf5ui4B7JJrNzYULVwT1z8NlGmlRYZTtg1F6z9E/rs:fit:784:767/czM6Ly9pY29uczgu/b3VjaC1wcm9kLmFz/c2V0cy9zdmcvOTY5/L2NlMTY1MWM5LTRl/ZjUtNGRmZi05MjQ3/LWYzNGQ1MzhiOTQ0/Mi5zdmc.png',
                  //       height: 400,
                  //     ),
                  //   ),
                  // ),
                ],
              ),
            ),
            const SizedBox(
              height: 40,
            ),
            textFormField(
              labelText: "Username",
              hintText: "general",
              iconData: Hicons.user_tag_2_bold,
            ),
            textFormField(
              labelText: "Phone Number",
              hintText: "+658362894910",
              iconData: Hicons.call_light_outline,
            ),
            const SizedBox(
              height: 30,
            ),
            Container(
              width: context.width,
              decoration: const BoxDecoration(color: Colors.blue, borderRadius: BorderRadius.all(Radius.circular(20))),
              clipBehavior: Clip.antiAlias,
              child: MaterialButton(
                onPressed: () async {
                  await context.navigator().pushReplacement(PageRouteBuilder(
                    pageBuilder: (context, animation, secondaryAnimation) {
                      HomePageAppTemplate homePageAppTemplate = HomePageAppTemplate(appTemplateData: widget.appTemplateData);

                      return homePageAppTemplate;
                    },
                  ));
                },
                height: 45,
                padding: const EdgeInsets.symmetric(vertical: 10, horizontal: 50),
                shape: RoundedRectangleBorder(
                  borderRadius: BorderRadius.circular(10.0),
                ),
                child: const Text(
                  "Reset Password",
                  style: TextStyle(color: Colors.white, fontSize: 16.0),
                ),
              ),
            ),
            const SizedBox(
              height: 30,
            ),
            Row(
              mainAxisAlignment: MainAxisAlignment.center,
              children: [
                Text(
                  'Have an account?',
                  style: TextStyle(color: context.theme.indicatorColor, fontSize: 14.0, fontWeight: FontWeight.w400),
                ),
                TextButton(
                  onPressed: () {
                    setState(() {
                      signPageTypeValueNotifier.value = SignPageType.sign_in;
                    });
                  },
                  child: const Text(
                    'Login',
                    style: TextStyle(color: Colors.blue, fontSize: 14.0, fontWeight: FontWeight.w400),
                  ),
                ),
              ],
            ),
          ],
        ),
      ),
    );
  }

  Widget textFormField({
    EdgeInsetsGeometry? padding,
    TextEditingController? controller,
    required String labelText,
    required String hintText,
    required IconData iconData,
    String? Function(String? value)? validator,

    // bool is_secret_data = false,
    ValueNotifier<bool>? valueState,
  }) {
    Widget child = Padding(
      padding: padding ??
          const EdgeInsets.symmetric(
            vertical: 5,
          ),
      child: TextFormField(
        controller: controller,
        cursorColor: context.theme.indicatorColor,
        validator: validator,
        obscureText: () {
          if (valueState != null) {
            return valueState.value;
          }
          return false;
        }(),
        decoration: InputDecoration(
          contentPadding: const EdgeInsets.all(0.0),
          labelText: labelText,
          hintText: hintText,
          hintStyle: const TextStyle(
            color: Colors.grey,
            fontSize: 14.0,
          ),
          labelStyle: TextStyle(
            color: context.theme.indicatorColor,
            fontSize: 14.0,
            fontWeight: FontWeight.w400,
          ),
          prefixIcon: Icon(
            iconData,
            color: context.theme.indicatorColor,
            size: 18,
          ),
          suffixIcon: (valueState != null)
              ? InkWell(
                  onTap: () {
                    setState(() {
                      valueState.value = (!valueState.value);
                    });
                  },
                  child: Icon(
                    Icons.remove_red_eye_outlined,
                    color: context.theme.indicatorColor,
                    size: 18,
                  ),
                )
              : null,
          focusColor: context.theme.indicatorColor,
          border: OutlineInputBorder(
            borderSide: BorderSide(color: Colors.grey.shade200, width: 2),
            borderRadius: BorderRadius.circular(10.0),
          ),
          floatingLabelStyle: TextStyle(
            color: context.theme.indicatorColor,
            fontSize: 18.0,
          ),
          focusedBorder: OutlineInputBorder(
            borderSide: BorderSide(
              width: 1.5,
              color: context.theme.indicatorColor,
            ),
            borderRadius: BorderRadius.circular(10.0),
          ),
        ),
      ),
    );
    // if (is_secret_data) {
    if (valueState != null) {
      return ValueListenableBuilder<bool>(
        valueListenable: valueState,
        builder: (_, mode, __) {
          return child;
        },
      );
    }
    // }
    return child;
  }
}
