// ignore_for_file: non_constant_identifier_names, empty_catches, argument_type_not_assignable_to_error_handler, unused_label, unused_local_variable, unnecessary_brace_in_string_interps, unnecessary_string_interpolations, unused_import

import 'dart:async';
import 'dart:convert';
import 'dart:io';
import 'dart:isolate';
import 'dart:math';
import 'dart:typed_data';

import 'package:telegram_client/telegram_client/telegram_client_core.dart';
import 'package:telegram_client/telegram_client/telegram_client_data.dart';
import 'package:telegram_client/telegram_client/telegram_client_type.dart';
import 'package:telegram_client/telegram_client/update_telegram_client.dart';
import 'package:telegram_userbot_template/database/database_core.dart';
import 'package:telegram_userbot_template/database/database_data_type.dart';
import 'package:telegram_userbot_template/database/default_database.dart';
import 'package:telegram_userbot_template/database/function/function.dart';
import 'package:telegram_userbot_template/extension/map.dart';
import 'package:telegram_userbot_template/extension/string.dart';
import 'package:telegram_userbot_template/scheme/chat_data.dart';
import 'package:telegram_userbot_template/scheme/tg_client_data.dart';
import 'package:telegram_userbot_template/telegram_userbot_template.dart';
// import 'package:brainly/brainly.dart';
import 'package:general_lib/general_lib.dart';
import 'package:stack_trace/stack_trace.dart';
import 'package:supabase/supabase.dart';

import 'package:xendit/xendit.dart';
import 'package:telegram_userbot_template/payment/scheme/scheme.dart'
    as tg_payment_scheme;

import 'package:supabase_client/supabase_client.dart' as supabase_client;
import "package:path/path.dart" as path;

Future<Map?> updateMessage(
  Map update, {
  required UpdateTelegramClient updateTelegramClient,
  required TelegramClient tg,
  required TgClientData tgClientData,
  required Database database,
}) async {
  int main_bot_user_id =
      int.tryParse(tg.telegramBotApi.token_bot.split(":")[0]) ?? 0;
  if (update["chat"]["type"] == "channel") {
    update["from"] = update["sender_chat"];
  }
  late bool isMainBot = false;
  if (main_bot_user_id == tgClientData.client_user_id) {
    isMainBot = true;
  }

  bool is_no_limitation =
      database.configRuntime.environment.is_no_limitation ?? false;
  int bot_user_id = int.tryParse(
          "${updateTelegramClient.client_option["token_bot"]}"
              .split(":")
              .first) ??
      0;
  late int current_admin_user_id = 0;
  late int current_from_client_client_id = 0;
  late String current_from_client_type = "core";
  late bool is_bot =
      (updateTelegramClient.client_option["is_login_bot"] == true)
          ? true
          : false;
  bool is_clean_userbot =
      (updateTelegramClient.client_option["is_clean_userbot"] == true);
  DatabaseDataType databaseDataType =
      (is_bot) ? DatabaseDataType.bot : DatabaseDataType.userbot;
  int current_user_id = 0;
  if (is_bot) {
    current_user_id = bot_user_id;
  } else if (updateTelegramClient.client_option["client_user_id"] is int) {
    current_user_id = updateTelegramClient.client_option["client_user_id"];
  }

  if (updateTelegramClient.client_option["from_client_type"] is String) {
    current_from_client_type =
        updateTelegramClient.client_option["from_client_type"];
  }
  if (updateTelegramClient.client_option["from_client_client_id"] is int) {
    current_from_client_client_id =
        updateTelegramClient.client_option["from_client_client_id"];
  }
  if (updateTelegramClient.client_option["admin_user_id"] is int) {
    current_admin_user_id = updateTelegramClient.client_option["admin_user_id"];
  }
  var msg = update;
  int msg_id = msg["message_id"];
  late String text = "";
  late String msg_caption = "";
  if (msg["text"] is String) {
    text = msg["text"];
  }
  late String caption = "";
  if (msg["caption"] is String) {
    caption = msg["caption"];
  }
  if (text.isNotEmpty) {
    msg_caption = text;
  }
  if (caption.isNotEmpty) {
    msg_caption = caption;
  }

  Map msg_from = msg["from"];
  Map msg_chat = msg["chat"];
  Map msg_auto_from = {
    "id": msg_from["id"],
  };

  msg_from.forEach((key, value) {
    msg_auto_from[key] = value;
  });

  Map msg_auto_chat = {
    "id": 0,
  };
  Map msg_bot = {
    "id": tgClientData.client_user_id,
    "is_bot": true,
  };

  int from_id = msg["from"]["id"];
  int chat_id = msg["chat"]["id"];

  String chat_type = msg["chat"]["type"]
      .toString()
      .replaceAll(RegExp(r"super", caseSensitive: false), "");
  String chat_type_private = "private";
  if (chat_type == chat_type_private) {
    msg_bot.forEach((key, value) {
      msg_auto_chat[key] = value;
    });
  } else {
    msg_chat.forEach((key, value) {
      msg_auto_chat[key] = value;
    });
  }

  int msg_auto_chat_id = msg_auto_chat["id"];

  int room_chat_id = chat_id;

  if (RegExp(r"^(private)$", caseSensitive: false).hashData(chat_type)) {
    room_chat_id = tgClientData.client_user_id ?? 0;
  }

  String chat_title = () {
    try {
      String msg_chat_title = "";
      if (msg_chat["title"] is String) {
        msg_chat_title += msg_chat["title"];
      }
      if (msg_chat["first_name"] is String) {
        msg_chat_title += msg_chat["first_name"];
      }
      if (msg_chat["last_name"] is String) {
        msg_chat_title += " ${msg_chat["last_name"]}";
      }

      if (msg_chat["last_name"] is String) {
        msg_chat_title += " ${msg_chat["last_name"]}";
      }

      return msg_chat_title;
    } catch (e) {}
    return "";
  }();
  var stringChatId =
      msg["chat"]["id"].toString().replaceAll(RegExp(r"(-100|-)"), "");

  if (msg["text"] is String) {
    text = msg["text"];
  }
  var isOutgoing = false;
  if (msg["is_outgoing"] is bool) {
    isOutgoing = msg["is_outgoing"];
  }
  if (msg["chat"] is Map == false) {
    return null;
  }
  var isAdmin = false;
  msg_from.forEach((key, value) {
    msg_auto_from[key] = value;
  });

  Map msg_current_chat = {
    "id": msg["chat"]["id"],
    ...msg_chat,
  };
  Map msg_current_user = {
    "id": current_user_id,
    "is_bot": true,
  };

  if (msg["chat"]["type"] is String == false) {
    msg["chat"]["type"] = "";
  }

  if (chat_type == chat_type_private) {
    // msg_bot.forEach((key, value) {
    //   msg_auto_chat[key] = value;
    // });
  } else {
    // msg_chat.forEach((key, value) {
    //   msg_auto_chat[key] = value;
    // });
  }

  if (chat_type == chat_type_private) {
    msg_from.forEach((key, value) {
      msg_current_chat[key] = value;
    });
  } else {
    msg_chat.forEach((key, value) {
      msg_current_chat[key] = value;
    });
  }

  int msg_current_chat_id = msg_current_chat["id"];

  if (RegExp(r"^(private)$", caseSensitive: false).hashData(chat_type)) {
    room_chat_id = tgClientData.client_user_id ?? 0;
  }

  if (updateTelegramClient.telegramClientData.is_bot == false) {
    if (isOutgoing) {
      isAdmin = true;
    } else {
      try {
        if (updateTelegramClient.client_option["owner_user_id"] ==
            msg["from"]["id"]) {
          isAdmin = true;
        }
      } catch (e, stack) {
        print("${e.toString()}, ${stack.toString()}");
      }
      try {
        if (updateTelegramClient.client_option["admin_user_id"] ==
            msg["from"]["id"]) {
          isAdmin = true;
        }
      } catch (e, stack) {
        print("${e.toString()}, ${stack.toString()}");
      }
    }
  }

  Map parameterPatch = {};
  if (msg["message_thread_id"] is int) {
    parameterPatch["message_thread_id"] = msg["message_thread_id"];
    if (updateTelegramClient.telegramClientData.telegramClientType ==
        TelegramClientType.tdlib) {
      if (msg["chat"]["detail"] is Map) {
        if (msg["chat"]["detail"]["is_forum"] != true) {
          parameterPatch.removeByKeys(["message_thread_id"]);
        }
      }
    }
  }

  // ignore: unused_element
  FutureOr<Map> request({
    required String method,
    Map? parameters,
    bool is_form = false,
    bool is_parse_mode = true,
    bool isVoid = false,
    TelegramClientData? telegramClientData,
    // String? tokenBot,
  }) async {
    parameters ??= {};
    parameters["@type"] = method;
    telegramClientData ??= updateTelegramClient.telegramClientData;
    // tokenBot ??= tgClientData.client_token;
    try {
      parameters.addAll(parameterPatch);
    } catch (e) {}
    if (is_parse_mode) {
      parameters["parse_mode"] = "html";
    } else {}
    parameters["allow_sending_without_reply"] = true;
    if (parameters["is_natural"] == true &&
        RegExp("^(send)", caseSensitive: false).hashData(method)) {
      String request_action = "typing";

      if (parameters.containsKey("document")) {
        request_action = "upload_document";
      }
      if (parameters.containsKey("sticker")) {
        request_action = "choose_sticker";
      }
      if (parameters.containsKey("voice")) {
        request_action = "record_voice";
      }

      if (parameters.containsKey("photo")) {
        request_action = "upload_photo";
      }

      if (parameters.containsKey("video")) {
        request_action = "upload_video";
      }
      await tg.request(
        parameters: {
          "@type": "sendChatAction",
          "chat_id": parameters["chat_id"],
          "action": request_action,
        },
        telegramClientData: telegramClientData,
        is_form: is_form,
      );

      String request_text = "";

      if (parameters["text"] is String) {
        request_text = parameters["text"];
      }
      if (parameters["caption"] is String) {
        request_text = parameters["caption"];
      }

      for (var i = 0; i < request_text.length; i++) {
        await Future.delayed(Duration(milliseconds: 1));
      }

      return (await tg.request(
        // method,
        parameters: parameters,

        telegramClientData: telegramClientData,
        // tokenBot: tokenBot,
        is_form: is_form,
        // isAutoExtendMessage: true,
      ));
    }
    return (await tg.request(
      // method,
      parameters: parameters,

      telegramClientData: telegramClientData,

      is_form: is_form,
      // isAutoExtendMessage: true,
    ));
  }

  if (RegExp(r"^((/|\.|!)ping)$", caseSensitive: false).hasMatch(text)) {
    String convertToAgo(int? timestamp) {
      try {
        Duration diff = DateTime.now()
            .copyWith(millisecond: 0, microsecond: 0)
            .difference(DateTime.fromMillisecondsSinceEpoch(
                timestamp ?? DateTime.now().millisecondsSinceEpoch));
        if (diff.inDays >= 1) {
          return '${diff.inDays} day(s) ago';
        } else if (diff.inHours >= 1) {
          return '${diff.inHours} hour(s) ago';
        } else if (diff.inMinutes >= 1) {
          return '${diff.inMinutes} minute(s) ago';
        } else if (diff.inSeconds >= 1) {
          return '${diff.inSeconds} second(s) ago';
        } else if (diff.inMilliseconds >= 1) {
          return '${diff.inMilliseconds} millisecond(s) ago';
        } else if (diff.inMicroseconds >= 1) {
          return '${diff.inMicroseconds} microsecond(s) ago';
        } else {
          return "just now";
        }
      } catch (e) {
        return 'just now';
      }
    }

    return await request(method: "sendMessage", parameters: {
      "chat_id": chat_id,
      "text": "🏓️ Pong: ${convertToAgo((msg["date"] * 1000))}"
          .autoVariableTelegram(msg, tgClientData: tgClientData),
    });
  }

  ChatData get_chat_me = await database.getChat(
    chat_type: chat_type_private,
    chat_id: current_user_id,
    tgClientData: tgClientData,
    databaseDataType: databaseDataType,
    room_chat_id: room_chat_id,
    onNotFoundData: () async {
      try {
        if (chat_type == "private") {
          msg_current_user["join_date"] = msg["date"];
          Map getMe = await request(method: "getMe");
          msg_current_user.addAll((getMe["result"] as Map));
        } else {
          try {
            Map getChatAdministrators = await request(
                method: "getChatAdministrators",
                parameters: {"chat_id": chat_id});
            if (getChatAdministrators["ok"] == true &&
                getChatAdministrators["result"] is List) {
              List admins_array = (getChatAdministrators["result"] as List);
              List id_admins =
                  admins_array.map((res) => res["user"]["id"]).toList();
              msg_current_user["admins"] = admins_array;
            }
          } catch (e, stack) {
            print("${e.toString()}, ${stack.toString()}");
          }
        }
        msg_current_user.updateVoid(data: DefaultDataBase.initData());

        ChatData chatData = ChatData(msg_current_user);
        try {
          chatData.rawData
              .updateVoid(data: database.configRuntime.config_init.toJson());
        } catch (e, stack) {
          print("${e.toString()}, ${stack.toString()}");
        }
        try {
          chatData.rawData
              .updateForce(data: database.configRuntime.config_force.toJson());
        } catch (e, stack) {
          print("${e.toString()}, ${stack.toString()}");
        }
        await database.saveChat(
          chat_type: chat_type_private,
          chat_id: current_user_id,
          newData: chatData.toJson(),
          tgClientData: tgClientData,
          room_chat_id: room_chat_id,
          databaseDataType: databaseDataType,
        );

        return chatData;
      } catch (e) {
        ChatData chatData = ChatData({
          "id": current_user_id,
        });
        return chatData;
      }
    },
  );

  if (get_chat_me.rawData.length == 1) {
    if (chat_type == "private") {
      msg_auto_chat["join_date"] = msg["date"];
      Map getMe = await request(method: "getMe");
      msg_auto_chat.addAll((getMe["result"] as Map));
    } else {
      try {
        Map getChatAdministrators = await request(
            method: "getChatAdministrators", parameters: {"chat_id": chat_id});
        if (getChatAdministrators["ok"] == true &&
            getChatAdministrators["result"] is List) {
          List admins_array = (getChatAdministrators["result"] as List);
          List id_admins =
              admins_array.map((res) => res["user"]["id"]).toList();
          msg_auto_chat["admins"] = admins_array;
        }
      } catch (e, stack) {
        print("${e.toString()}, ${stack.toString()}");
      }
    }

    msg_auto_chat.updateVoid(data: DefaultDataBase.initData());

    get_chat_me = ChatData(msg_auto_chat);
    try {
      get_chat_me.rawData
          .updateVoid(data: database.configRuntime.config_init.toJson());
    } catch (e, stack) {
      print("${e.toString()}, ${stack.toString()}");
    }
    try {
      get_chat_me.rawData
          .updateForce(data: database.configRuntime.config_force.toJson());
    } catch (e, stack) {
      print("${e.toString()}, ${stack.toString()}");
    }
    await database.saveChat(
      chat_type: chat_type_private,
      chat_id: current_user_id,
      newData: get_chat_me.toJson(),
      tgClientData: tgClientData,
      room_chat_id: room_chat_id,
      databaseDataType: databaseDataType,
    );
  } else {
    try {
      get_chat_me.rawData
          .updateVoid(data: database.configRuntime.config_init.toJson());
    } catch (e, stack) {
      print("${e.toString()}, ${stack.toString()}");
    }
    try {
      get_chat_me.rawData
          .updateForce(data: database.configRuntime.config_force.toJson());
    } catch (e, stack) {
      print("${e.toString()}, ${stack.toString()}");
    }
  }

  late ChatData get_chat_data;

  ChatData get_user_data = await database.getChat(
    chat_type: chat_type_private,
    chat_id: from_id,
    value: msg_from,
    tgClientData: tgClientData,
    room_chat_id: room_chat_id,
    isWithoutFetch: (chat_type != "private")
        ? (database.configRuntime.environment.is_skip_get_db_user ?? false)
        : false,
    onNotFoundData: () async {
      try {
        try {
          msg_from.updateVoid(data: DefaultDataBase.initData(isUser: true));
        } catch (e) {}
        ChatData chatData = ChatData(msg_from);
        // if (database.configRuntime);
        await database.saveChat(
          chat_type: chat_type_private,
          chat_id: from_id,
          newData: msg_from,
          tgClientData: tgClientData,
          room_chat_id: room_chat_id,
        );

        return chatData;
      } catch (e) {
        ChatData chatData = ChatData(msg_from);

        return chatData;
      }
    },
  );
  try {
    get_user_data.rawData
        .updateVoid(data: DefaultDataBase.initData(isUser: true));
  } catch (e) {}

  if (chat_type == "private") {
    get_chat_data = ChatData({...get_user_data.toJson()});
  } else {
    get_chat_data = await database.getChat(
      chat_type: chat_type,
      chat_id: msg_auto_chat_id,
      value: msg_auto_chat,
      isSaveNotFound: false,
      tgClientData: tgClientData,
      room_chat_id: room_chat_id,
      onNotFoundData: () async {
        try {
          if (chat_type == "private") {
            msg_auto_chat["join_date"] = msg["date"];
            Map getMe = await request(method: "getMe");
            msg_auto_chat.addAll((getMe["result"] as Map));
          } else {}

          try {
            msg_auto_chat.updateVoid(
                data: DefaultDataBase.initData(isUser: false));
          } catch (e) {}
          ChatData chatData = ChatData(msg_auto_chat);
          await database.saveChat(
            chat_type: chat_type,
            chat_id: msg_auto_chat_id,
            newData: msg_auto_chat,
            tgClientData: tgClientData,
            room_chat_id: room_chat_id,
          );
          return chatData;
        } catch (e) {
          ChatData chatData = ChatData(msg_auto_chat);
          await database.saveChat(
            chat_type: chat_type,
            chat_id: msg_auto_chat_id,
            newData: msg_auto_chat,
            tgClientData: tgClientData,
            room_chat_id: room_chat_id,
          );
          return chatData;
        }
      },
    );

    try {
      get_chat_data.rawData
          .updateVoid(data: DefaultDataBase.initData(isUser: false));
    } catch (e) {}
    try {
      get_chat_data.rawData
          .updateForce(data: database.configRuntime.config_force.toJson());
    } catch (e) {}
  }

  try {
    if (get_chat_me.is_natural == true) {
      if (updateTelegramClient.client_option["is_login_bot"] != true) {
        parameterPatch.addAll({
          "is_natural": true,
        });
      }
    }
  } catch (e) {}

  if (RegExp(r"^((/|\.|!)test_get_data)$", caseSensitive: false)
      .hasMatch(text)) {
    String data_origin = get_chat_me["data_origin"] ?? "";
    await database.saveChat(
      chat_type: chat_type_private,
      chat_id: current_user_id,
      newData: get_chat_me.toJson(),
      tgClientData: tgClientData,
      room_chat_id: room_chat_id,
      databaseDataType: databaseDataType,
    );

    return await request(method: "sendMessage", parameters: {
      "chat_id": chat_id,
      "text": "🏓️ Succes Get\n\nData Origin: ${data_origin}"
          .autoVariableTelegram(msg, tgClientData: tgClientData),
    });
  }
  if (RegExp(r"^((/|\.|!)test_set_data)$", caseSensitive: false)
      .hasMatch(text)) {
    String data_origin = get_chat_me["data_origin"] ?? "";
    String new_data = DateTime.now().toString();

    get_chat_me["data_origin"] = new_data;

    await database.saveChat(
      chat_type: chat_type_private,
      chat_id: current_user_id,
      newData: get_chat_me.toJson(),
      tgClientData: tgClientData,
      room_chat_id: room_chat_id,
      databaseDataType: databaseDataType,
    );

    return await request(method: "sendMessage", parameters: {
      "chat_id": chat_id,
      "text": "🏓️ Succes\n\nData Origin: ${data_origin}\nNew: ${new_data}"
          .autoVariableTelegram(msg, tgClientData: tgClientData),
    });
  }
  return null;
}
